package com.gyee.frame.service.impl.ticket;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.gyee.frame.common.exception.TicketException;
import com.gyee.frame.model.ticket.Ibsidgen;
import com.gyee.frame.model.ticket.Wosafety;
import com.gyee.frame.mapper.ticket.WosafetyMapper;
import com.gyee.frame.service.ticket.IbsidgenService;
import com.gyee.frame.service.ticket.WosafetyService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author chenmh
 * @since 2020-06-08
 */
@Service
public class WosafetyServiceImpl extends ServiceImpl<WosafetyMapper, Wosafety> implements WosafetyService {

    @Autowired
    IbsidgenService ibsidgenService;

    @Transactional
    @Override
    public void insertSafeMeasure(Wosafety obj) {
        Ibsidgen gen = ibsidgenService.selectId("WOSAFETY");
        double id = gen.getIdvalue() + 1;
        ibsidgenService.updateGen(gen, id);

        obj.setId(id);
        int result = baseMapper.insert(obj);

        if (result== 0)
            throw new TicketException("数据添加失败");
    }

    @Override
    public List<Wosafety> getListSafeMeasure(String woNum) {
        QueryWrapper<Wosafety> wrapper = new QueryWrapper<>();
        wrapper.eq("WONUM", woNum);

        List<Wosafety> wosafeties = baseMapper.selectList(wrapper);

        return wosafeties;
    }

    @Override
    public Integer deleteSafeMeasure(List<Double> list) {
        int result = baseMapper.deleteBatchIds(list);
        return result;
    }
}
